
# AllCops:
#   NewCops: enable

AllCops:
  TargetRubyVersion: 2.7

Layout/EmptyLinesAroundClassBody:
  Enabled: false

Layout/SpaceInsideHashLiteralBraces:
  Enabled: false

Layout/SpaceAroundOperators:
  Enabled: false

Layout/MultilineHashBraceLayout:
  Enabled: false

Naming/MethodParameterName:
  MinNameLength: 2

# Style

# Style/StringLiterals:
#   EnforcedStyle: double_quotes

Style/Documentation:
  Enabled: false

Style/FrozenStringLiteralComment:
  Enabled: false

Style/BlockComments:
  Enabled: false

Style/EmptyMethod:
  Enabled: false

Style/NestedTernaryOperator:
  Enabled: false

Style/RedundantReturn:
  Enabled: false

Style/ParenthesesAroundCondition:
  Enabled: false
Style/AsciiComments:
  Enabled: false

Style/NumericPredicate:
  Enabled: false

Style/SymbolArray:
  Enabled: false

Style/BlockDelimiters:
  EnforcedStyle: 'braces_for_chaining'

Style/WordArray:
  Enabled: false

# Metrics
Layout/LineLength:
  Max: 180  # Choisir une valeur qui nous convient à tous.

Metrics/MethodLength:
  Max: 50  # Ici aussi choisir une valeur qui nous convient à tous.
            # Si besoin on peut exclure certaines fonctions spécifique, à utiliser avec modération !
  ExcludedMethods: ['union_calcul']

Metrics/AbcSize:
  Enabled: false  # A voir s'il faut l'enlever...

# Complexity
Metrics/PerceivedComplexity:
  Max: 12 # default = 7 => un peu insuffisant pour nos algos !

Metrics/CyclomaticComplexity:
  Max: 10 # default = 6 => un peu insuffisant pour nos algos !

#Metrics/MethodLength:
#  ExcludedMethods: ["puts"]


########################################################
# New cops

Layout/BeginEndAlignment: # (new in 0.91)
  Enabled: true
Layout/EmptyLinesAroundAttributeAccessor: # (new in 0.83)
  Enabled: true
Layout/SpaceAroundMethodCallOperator: # (new in 0.82)
  Enabled: true
Lint/BinaryOperatorWithIdenticalOperands: # (new in 0.89)
  Enabled: true
Lint/ConstantDefinitionInBlock: # (new in 0.91)
  Enabled: true
Lint/DeprecatedOpenSSLConstant: # (new in 0.84)
  Enabled: true
Lint/DuplicateElsifCondition: # (new in 0.88)
  Enabled: true
Lint/DuplicateRequire: # (new in 0.90)
  Enabled: true
Lint/DuplicateRescueException: # (new in 0.89)
  Enabled: true
Lint/EmptyConditionalBody: # (new in 0.89)
  Enabled: true
Lint/EmptyFile: # (new in 0.90)
  Enabled: true
Lint/FloatComparison: # (new in 0.89)
  Enabled: true
Lint/IdentityComparison: # (new in 0.91)
  Enabled: true
# Lint/MissingSuper: # (new in 0.89)
#   Enabled: true
Lint/MixedRegexpCaptureTypes: # (new in 0.85)
  Enabled: true
Lint/OutOfRangeRegexpRef: # (new in 0.89)
  Enabled: true
Lint/RaiseException: # (new in 0.81)
  Enabled: true
Lint/SelfAssignment: # (new in 0.89)
  Enabled: true
Lint/StructNewOverride: # (new in 0.81)
  Enabled: true
Lint/TopLevelReturnWithArgument: # (new in 0.89)
  Enabled: true
Lint/TrailingCommaInAttributeDeclaration: # (new in 0.90)
  Enabled: true
Lint/UnreachableLoop: # (new in 0.89)
  Enabled: true
Lint/UselessMethodDefinition: # (new in 0.90)
  Enabled: true
Lint/UselessTimes: # (new in 0.91)
  Enabled: true
Style/AccessorGrouping: # (new in 0.87)
  Enabled: true
Style/BisectedAttrAccessor: # (new in 0.87)
  Enabled: true
# Style/CaseLikeIf: # (new in 0.88)
#   Enabled: true
Style/CombinableLoops: # (new in 0.90)
  Enabled: true
Style/ExplicitBlockArgument: # (new in 0.89)
  Enabled: true
Style/ExponentialNotation: # (new in 0.82)
  Enabled: true
Style/GlobalStdStream: # (new in 0.89)
  Enabled: true
# Style/HashAsLastArrayItem: # (new in 0.88)
#   Enabled: true
Style/HashEachMethods: # (new in 0.80)
  Enabled: true
Style/HashLikeCase: # (new in 0.88)
  Enabled: true
Style/HashTransformKeys: # (new in 0.80)
  Enabled: true
Style/HashTransformValues: # (new in 0.80)
  Enabled: true
Style/KeywordParametersOrder: # (new in 0.90)
  Enabled: true
Style/OptionalBooleanParameter: # (new in 0.89)
  Enabled: true
Style/RedundantAssignment: # (new in 0.87)
  Enabled: true
Style/RedundantFetchBlock: # (new in 0.86)
  Enabled: true
Style/RedundantFileExtensionInRequire: # (new in 0.88)
  Enabled: true
Style/RedundantRegexpCharacterClass: # (new in 0.85)
  Enabled: true
Style/RedundantRegexpEscape: # (new in 0.85)
  Enabled: true
Style/RedundantSelfAssignment: # (new in 0.90)
  Enabled: true
Style/SingleArgumentDig: # (new in 0.89)
  Enabled: true
Style/SlicingWithRange: # (new in 0.83)
  Enabled: true
Style/SoleNestedConditional: # (new in 0.89)
  Enabled: true
# Style/StringConcatenation: # (new in 0.89)
#   Enabled: true
